Redmine - Feature #6779

Project JSON API
2010-10-31 17:00 - Patrick Logé

Status: Closed Start date: 2010-10-31
Priority: Normal Due date:

Assignee: % Done: 0%
Category: REST API Estimated time: 0.00 hour
Target version: 1.1.0

Resolution: Fixed

Description

| doesn't seem to be possible to get projects as JSON
| did add this

def index
respond_to do |format|
>>>>>>> format.json { render :text => Project.visible.find(:all, :order => 'lft').to_json,
layout => false }

format.html {
@projects = Project.visible.find(:all, :order => 'l1ft"')

}

format .xml
@projects = Project.visible.find(:all, :order => '1lft')

}

format.atom {
projects = Project.visible.find(:all, :order => 'created_on DESC',

:limit => Setting.feeds_limit.to_1i)

render_feed(projects, :title => "#{Setting.app_title}: #{1l(:label_project_latest)}")

}

end

—_—

end

to make it work

in the

History

#1 - 2010-11-01 01:06 - Terence Mill

nice alternative to complete redmine api, isn't it?

#2 - 2010-11-01 14:22 - Jean-Philippe Lang
- Category changed from Projects to REST API

- Target version set to 1.1.0

#3 - 2010-11-01 16:01 - Eric Davis

- Subject changed from Projects with JSON to Project JSON API
- Status changed from New to 7

- Assignee set to Eric Davis

- Priority changed from Low to Normal

- Estimated time deleted (1.00 h)

Looks like the JSON api for projects was missed. I'm going to be reviewing the existing APIs and trying to clean them up over the next few weeks.

#4 - 2010-11-01 18:42 - Patrick Logé
Great thank!
Another info:

| wanted to use JSON to create a mobile application with Rhomobile

| had problems with the "Issues" REST interface because of illegal characters.
Rhomobile have a "Rho::AsyncHitp.get" method to consume JSON services.
My Redmine instance return something like

[{"start_date":"2010/09/10","deliverable_id":211,"estimated_hours":null, "priority_id":4,"created_on":"2010/09/
10 16:56:56

+0200", "project_id":278, "root_id":8117, "lock_version":3,"1ft":1,"fixed_version_id":113, "updated_on":"2010/09/1
3 20:47:44

+0200", "subject":"Adaptations","id":8117, "done_ratio":90, "assigned_to_id":11, "tracker_id":2, "category_id":null
,"parent_id":null,

"due_date":null, "status_id":2,"description":"Hello, Anglais =\uOO03E","author_id":255,"rgt":2}]

I noticed a problem with the last character "\uO03E". Once replace by "\u003e" (lowercase) it worked !!
So | did modify the Issues controller to return lowercase UTF8 entities.

format.json {
j = @issues.to_json
j.gsub! (/(u00) (.?) (.?)/){In| n.downcase}
render :text => j, :layout => false

}

instead of

format.json { render :text => @issues.to_json, :layout => false }
Strange....
| don't know where the problem comes from. | sent a ticket to Rhomobile
#5 - 2010-11-09 19:39 - James Hardy
Patrick Logé wrote:
| noticed a problem with the last character "\uOO3E". Once replace by "\u003e" (lowercase) it worked !!

So | did modify the Issues controller to return lowercase UTF8 entities.

From http://www.ietf.org/rfc/rfc4627.txt?number=4627 section 2.5 defining JSON, a unicode escape sequence is:

a reverse solidus, followed

by the lowercase letter u, followed by four hexadecimal digits that
encode the character's code point. The hexadecimal letters A though
F can be upper or lowercase.

so it would appear to be the client library which is at fault

#6 - 2010-11-27 00:40 - Eric Davis

- Assignee deleted (Eric Davis)

| am stepping down from working on Redmine. |f someone else is interesting in working on this issue, feel free to reassign it to them.

Eric Davis

#7 - 2010-12-03 13:41 - Jean-Philippe Lang
- Status changed from 7 to Closed

- Resolution set to Fixed

Projects JSON API available in r4456.
